extends KinematicBody2D

export var speed = 5

onready var world = get_parent()

onready var innovative_01 = get_node("Innovative_01")
onready var innovative_02 = get_node("Innovative_02")
onready var innovative_03 = get_node("Innovative_03")
onready var innovative_04 = get_node("Innovative_04")
onready var communicative_01 = get_node("Communicative_01")
onready var communicative_02 = get_node("Communicative_02")
onready var communicative_03 = get_node("Communicative_03")
onready var communicative_04 = get_node("Communicative_04")
onready var creative_01 = get_node("Creative_01")
onready var creative_02 = get_node("Creative_02")
onready var creative_03 = get_node("Creative_03")
onready var creative_04 = get_node("Creative_04")
onready var versatile_01 = get_node("Versatile_01")
onready var versatile_02 = get_node("Versatile_02")
onready var versatile_03 = get_node("Versatile_03")
onready var versatile_04 = get_node("Versatile_04")

onready var card_collider_detection = get_node("CollisionShape2D")

onready var all_cards = [innovative_01, innovative_02, innovative_03, innovative_04, communicative_01, communicative_02, communicative_03, communicative_04, creative_01, creative_02, creative_03, creative_04, versatile_01, versatile_02, versatile_03, versatile_04]

var cards_already_collected = []
var random_number = RandomNumberGenerator.new()
var player_collected_card = false
var active_card
var index
var card_entered_screen = false
var game_over_instance


# Called every frame. 'delta' is the elapsed time since the previous frame.
func _physics_process(delta):
	var collision = move_and_collide(Vector2(-speed, 0), false)
	
	if collision != null and collision.collider.is_in_group("player"):
		card_collider_detection.disabled = true
		world.ChangeScore()
		player_collected_card = true


# Pick a random card.
func PickRandomCard():
	if all_cards.size() > 0:
		index = random_number.randi_range(0, (all_cards.size() - 1))
		active_card = all_cards[index]
		active_card.visible = true


# Remove collected card.
func RemoveCardWhichWasCollected():
	cards_already_collected.append(active_card.name)
	all_cards.remove(index)
	active_card.visible = false


# If the player lost, check which cards were collected.
func PrepareCardsWhichWereCollected():
	if cards_already_collected.size() > 0 and game_over_instance != null:
		if innovative_01.name in cards_already_collected:
			game_over_instance.collectedCards.append(game_over_instance.card01)
		
		if innovative_02.name in cards_already_collected:
			game_over_instance.collectedCards.append(game_over_instance.card02)
		
		if innovative_03.name in cards_already_collected:
			game_over_instance.collectedCards.append(game_over_instance.card03)
		
		if innovative_04.name in cards_already_collected:
			game_over_instance.collectedCards.append(game_over_instance.card04)
		
		if communicative_01.name in cards_already_collected:
			game_over_instance.collectedCards.append(game_over_instance.card05)
		
		if communicative_02.name in cards_already_collected:
			game_over_instance.collectedCards.append(game_over_instance.card06)
		
		if communicative_03.name in cards_already_collected:
			game_over_instance.collectedCards.append(game_over_instance.card07)
		
		if communicative_04.name in cards_already_collected:
			game_over_instance.collectedCards.append(game_over_instance.card08)
		
		if creative_01.name in cards_already_collected:
			game_over_instance.collectedCards.append(game_over_instance.card09)
		
		if creative_02.name in cards_already_collected:
			game_over_instance.collectedCards.append(game_over_instance.card10)
		
		if creative_03.name in cards_already_collected:
			game_over_instance.collectedCards.append(game_over_instance.card11)
		
		if creative_04.name in cards_already_collected:
			game_over_instance.collectedCards.append(game_over_instance.card12)
		
		if versatile_01.name in cards_already_collected:
			game_over_instance.collectedCards.append(game_over_instance.card13)
		
		if versatile_02.name in cards_already_collected:
			game_over_instance.collectedCards.append(game_over_instance.card14)
		
		if versatile_03.name in cards_already_collected:
			game_over_instance.collectedCards.append(game_over_instance.card15)
		
		if versatile_04.name in cards_already_collected:
			game_over_instance.collectedCards.append(game_over_instance.card16)


# When the card leaves the screen.
func _on_VisibilityNotifier2D_screen_exited():
	player_collected_card = false # reset value
	card_entered_screen = false


# When the card enters the screen.
func _on_VisibilityNotifier2D_screen_entered():
	card_entered_screen = true
