extends Control

onready var card01 = get_node("AllCards/Card01")
onready var card02 = get_node("AllCards/Card02")
onready var card03 = get_node("AllCards/Card03")
onready var card04 = get_node("AllCards/Card04")
onready var card05 = get_node("AllCards/Card05")
onready var card06 = get_node("AllCards/Card06")
onready var card07 = get_node("AllCards/Card07")
onready var card08 = get_node("AllCards/Card08")
onready var card09 = get_node("AllCards/Card09")
onready var card10 = get_node("AllCards/Card10")
onready var card11 = get_node("AllCards/Card11")
onready var card12 = get_node("AllCards/Card12")
onready var card13 = get_node("AllCards/Card13")
onready var card14 = get_node("AllCards/Card14")
onready var card15 = get_node("AllCards/Card15")
onready var card16 = get_node("AllCards/Card16")

onready var cardNumber = get_node("CardNumber")
onready var nextCardButton = get_node("NextCard")
onready var previousCardButton = get_node("PreviousCard")

var pointsOfPlayer
var collectedCards = []
var shownCard
var currentActiveIndex = 0


# This function lets you restart the game.
func _on_RestartButton_pressed():
	get_tree().change_scene("res://Scenes/World.tscn")
	get_tree().paused = false # unpause game in background
	get_parent().remove_child(self) # remove gameover Screen


# This function lets you return to the main menu.
func _on_MenuButton_pressed():
	get_tree().change_scene("res://Scenes/MainMenu.tscn")
	get_parent().remove_child(self) # remove gameover Screen


# This function lets you exit the game.
func _on_ExitButton_pressed():
	get_tree().quit()


# This function shows the amount of collected cards.
func ShowPoints():
	var pointsLabel = get_node("Points")
	pointsLabel.set_text(str(pointsOfPlayer) + "/16")


# Shows the first card on the game over screen if a card was collected.
func ShowCollectedCard():
	if collectedCards.size() > 0:
		shownCard = collectedCards[0]
		shownCard.visible = true
		cardNumber.set_text("Karte: " + str(currentActiveIndex + 1) + "/" + str(collectedCards.size()))
	
	if collectedCards.size() <= 1:
		nextCardButton.disabled = true
		nextCardButton.visible = false
		
		previousCardButton.disabled = true
		previousCardButton.visible = false


# After clicking on the button, show the next card.
func _on_NextCard_pressed():
	if collectedCards.size() > 0:
		# hide old card
		shownCard = collectedCards[currentActiveIndex]
		shownCard.visible = false
	
		# show next card
		currentActiveIndex += 1
	
		if currentActiveIndex >= collectedCards.size(): #reset
			currentActiveIndex = 0
	
		shownCard = collectedCards[currentActiveIndex]
		shownCard.visible = true
		cardNumber.set_text("Karte: " + str(currentActiveIndex + 1) + "/" + str(collectedCards.size()))


func _on_PreviousCard_pressed():
	if collectedCards.size() > 0:
		# hide old card
		shownCard = collectedCards[currentActiveIndex]
		shownCard.visible = false
	
		# show next card
		currentActiveIndex -= 1
	
		if currentActiveIndex < 0: #reset
			currentActiveIndex = collectedCards.size() - 1
	
		shownCard = collectedCards[currentActiveIndex]
		shownCard.visible = true
		cardNumber.set_text("Karte: " + str(currentActiveIndex + 1) + "/" + str(collectedCards.size()))
